// Serial758UI.h : main header file for the SERIAL758UI application
//

#if !defined(AFX_SERIAL758UI_H__27E84564_EFBC_11D3_856B_D7BBD9D20561__INCLUDED_)
#define AFX_SERIAL758UI_H__27E84564_EFBC_11D3_856B_D7BBD9D20561__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
#include "SerialCommTestDlg.h"
#include "Port.h"
#include "WriteCommThread.h"
#include "ReadStatusCommThread.h"
#include "Test.h"

#define MAXPORTS 8
#define PACKETSIZE 150

/////////////////////////////////////////////////////////////////////////
// CSerial758UIApp:
// See Serial758UI.cpp for the implementation of this class
//

class CSerial758UIApp : public CWinApp
{
public:
	CString m_Delay;
	
	void ClosePorts();
	bool m_bSetUp;
	bool m_bTestStop;
	bool m_bTestStart;
	CTest m_PortTest;
	void OnPortCreation();
	
	struct PortSettings
	{
		int nBaud;
		int nDataBits;
		int nParity;
		int nStopBits;
		int nComBase;
		int nRS485;
		int nIR;
		int nRTS;
		int nDTR;
		int nTxFIFO;
		int nRxFIFO;
		int nFlowCtrl;
		int nPortOpen;
		int nDTRHys;
		int nRTSHys;
		int nRxTrig;
		int nTxTrig;	
	};

/*	struct ErrCheck
	{
		int ntempReadBytes;
		bool bInCompleteRead;
		int nFileBytes;
		int nFileIndex;
		bool bFilePending;

	};*/
	
//	ErrCheck m_structErrChecking[MAXPORTS];

	/*struct Test//used in Test class
	{
		int nTotalTestTime;
		int nErrCount;
		int nLineCount;
		bool bTestStop;
	};*/

	/*struct Transfer
	{
		int nQuickBrown;
		int nAlpha;
		int nFile;
		int nUserData;
		CString strUser;
		unsigned char SendFileBuff[60000];
		int nSendFileBytes;
	};*/

	struct SerialTest
	{
		int nDisONOFF;
		int nTestForever;
		int nStopError;
		int nStopTime;
		int nLoopTest;
		CString strHrTime;
		CString strMinTime;
		CString strTx;
		CString strRx;
	};

	struct PortRegistry
	{
		int nBaud;//port
		int nDataBits;
		int nParity;
		int nStopBits;
		int nComBase;
		int nRS485;
		int nIR;
		int nRTS;
		int nDTR;
		int nTxFIFO;
		int nRxFIFO;
		int nFlowCtrl;
		int nPortOpen;
		int nDTRHys;
		int nRTSHys;
		int nRxTrig;
		int nTxTrig;	
		int nTestForever;//test
		int nStopError;
		int nStopTime;
		int nLoopTest;
		int nDisONOFF;
		int strHrTime;
		int strMinTime;
		int nQuickBrown;//transfer
		int nAlpha;
		int nFile;
		int nUserData;
	};

	struct inttostrRegistry//contains all the parameters in registry which has to be converted into strings
	{
		int strHrTime;
		int strMinTime;
	};

	struct port
	{
		HANDLE hPortHandle[MAXPORTS];
		CPort Port;
		int nPortOpenCount;
		bool bOnePortFlag;
		HANDLE hThreadExit;
		CWinThread* pWriteThread;
		HANDLE hWrite;
		bool bPortOpenFlag[MAXPORTS];
		bool bThreadContinue;
	};

	struct writethreadparam
	{
		//CWinThread* pWriteThread;
		int nWriteBytes;
		bool bWriteNowFlag;
		//HANDLE hWrite;		
		unsigned char WriteBuff[500];	
	};	
	struct readthreadparam
	{
		CWinThread *pReadThread;
		int nReadBytes;	
		unsigned char ReadBuff[500];
	};

	RECT m_ClientRect;
	int m_nRunCount;
	port m_structPort;
	PortRegistry m_PortRegistry[MAXPORTS];
	inttostrRegistry m_itoaRegistry[MAXPORTS];

	writethreadparam m_WriteThreadParam[MAXPORTS];
	WriteThreadInfo m_WriteThreadInfo;

	readthreadparam m_ReadThreadParam[MAXPORTS];
	ReadThreadInfo m_ReadThreadInfo[MAXPORTS];

	//OVERLAPPED m_OverLapped[MAXPORTS];

//	bool m_bStopPressed;

	//CSerialCommTestDlg* m_pSerialCommTestDlg;

	PortSettings m_structPortSettingsDlg[MAXPORTS];
	//Transfer m_TransferDataDlg[MAXPORTS];
	SerialTest m_TestDlg[MAXPORTS];
	
	CSerial758UIApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSerial758UIApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CSerial758UIApp)
	afx_msg void OnAppAbout();
	afx_msg void OnTestStart();
	afx_msg void OnConfigLoad();
	afx_msg void OnConfigSave();
	afx_msg void OnTestStop();
	afx_msg void OnUpdateTestStop(CCmdUI* pCmdUI);
	afx_msg void OnSetupPortsettings();
	afx_msg void OnUpdateSetupPortsettings(CCmdUI* pCmdUI);
	afx_msg void OnUpdateTestStart(CCmdUI* pCmdUI);
	afx_msg void OnConfigHelp();
	afx_msg void OnUpdateConfigLoad(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAppExit(CCmdUI* pCmdUI);
	afx_msg void OnTestDelay();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SERIAL758UI_H__27E84564_EFBC_11D3_856B_D7BBD9D20561__INCLUDED_)
