// UserDataDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Serial758UI.h"
#include "UserDataDlg.h"
#include "GlobalVar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern TRANSFERSTRUCT m_TransferDataDlg[MAXPORTS];
/////////////////////////////////////////////////////////////////////////////
// CUserDataDlg dialog


CUserDataDlg::CUserDataDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUserDataDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUserDataDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CUserDataDlg::CUserDataDlg(int nPortNo,CWnd* pParent /*=NULL*/)
	: CDialog(CUserDataDlg::IDD, pParent)
{
	m_nPortNo=nPortNo-1;
}


void CUserDataDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUserDataDlg)
	DDX_Control(pDX, IDC_USERDEFINED, m_radioUserDef);
	DDX_Control(pDX, IDC_USERDATA, m_editUserData);
	DDX_Control(pDX, IDC_QUICKBROWN, m_radioQuickBrown);
	DDX_Control(pDX, IDC_FILE, m_radioFile);
	DDX_Control(pDX, IDC_ALPHABETS, m_radioAlpha);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUserDataDlg, CDialog)
	//{{AFX_MSG_MAP(CUserDataDlg)
	ON_BN_CLICKED(IDC_USERDEFINED, OnUserdefinedData)
	ON_BN_CLICKED(IDC_FILE, OnTransferFile)
	ON_BN_CLICKED(IDC_QUICKBROWN, OnQuickbrown)
	ON_BN_CLICKED(IDC_ALPHABETS, OnAlphabets)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUserDataDlg message handlers

void CUserDataDlg::OnUserdefinedData() 
{
	m_editUserData.EnableWindow(TRUE);
}

void CUserDataDlg::OnTransferFile() 
{
	//Here the user has selected a file to be sent from Transfer menu command.
	//The file is read into a buffer of max. size of 60000 bytes.

	//CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	m_editUserData.EnableWindow(FALSE);//disable the user defined edit box

	int nRet;
	CString str="Send File";
		
	CFileDialog sendfile(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|
		OFN_FILEMUSTEXIST,"Text File Only(*.txt)|*.txt||");//construct the dialog to check if the file and path exists
	sendfile.m_ofn.lpstrTitle= str;//set the title of the dialog as "Send File"
	nRet=sendfile.DoModal();//invoke the dialog
	if(nRet == IDOK)
	{
		CString filename=sendfile.GetFileName();
		m_file.Open(filename,CFile::modeRead,NULL);//open the file in read mode
		m_file.SeekToBegin();//set the file pointer to the start of the file
		DWORD dwlength=m_file.GetLength();//get the length of the file
		
		if (dwlength > 60000)//buffer size is limited to 60000
			m_TransferDataDlg[m_nPortNo].nSendFileBytes=60000;//if the logical length of the file is greater than 60000, then truncate
		else
			m_TransferDataDlg[m_nPortNo].nSendFileBytes=dwlength;
		m_file.Read(m_TransferDataDlg[m_nPortNo].SendFileBuff,m_TransferDataDlg[m_nPortNo].nSendFileBytes);//read the data in the file into the ReadBuff
		
		m_file.Close();	//close the file m_file	

		OnOK();
	}
	
}

void CUserDataDlg::OnAlphabets() 
{
	m_editUserData.EnableWindow(FALSE);	
}

void CUserDataDlg::OnQuickbrown() 
{
	m_editUserData.EnableWindow(FALSE);	
}

BOOL CUserDataDlg::OnInitDialog() 
{
	//initializes the dialog controls to the stored values

	CDialog::OnInitDialog();
	
	m_editUserData.SetLimitText(PACKETSIZE-50);//limit the user defined text to 450 bytes
	
	m_radioAlpha.SetCheck(m_TransferDataDlg[m_nPortNo].nAlpha);
	m_radioQuickBrown.SetCheck(m_TransferDataDlg[m_nPortNo].nQuickBrown);
	//if(m_TransferDataDlg[m_nPortNo].nFile)//if the user has selected file previously,
		                                  //next when you open select alpha
		                                  //and not file
	//	m_radioAlpha.SetCheck(m_TransferDataDlg[m_nPortNo].nFile);

	m_radioFile.SetCheck(m_TransferDataDlg[m_nPortNo].nFile);
	m_radioUserDef.SetCheck(m_TransferDataDlg[m_nPortNo].nUserData);
	m_editUserData.SetWindowText(m_TransferDataDlg[m_nPortNo].strUser);

	if(m_TransferDataDlg[m_nPortNo].nUserData)//if user data radio button is checked
		m_editUserData.EnableWindow(TRUE);	
	else
		m_editUserData.EnableWindow(FALSE);	

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CUserDataDlg::OnOK() 
{
	//stores the selected values into the registry variables
	
	m_TransferDataDlg[m_nPortNo].nAlpha=m_radioAlpha.GetCheck();
	m_TransferDataDlg[m_nPortNo].nQuickBrown=m_radioQuickBrown.GetCheck();
	m_TransferDataDlg[m_nPortNo].nFile=m_radioFile.GetCheck();
	int nRet = m_TransferDataDlg[m_nPortNo].nUserData=m_radioUserDef.GetCheck();
	if(nRet)
		m_editUserData.GetWindowText(m_TransferDataDlg[m_nPortNo].strUser);	
	
	CDialog::OnOK();
}

