////////////////////////////////////////
//(c) 1999, 2000 EXAR Corporation 
//All Rights Reserved.
//
//Exar Corporation ("Exar") hereby grants the User of this Exar 
//product-specific XR17C158 Windows NT Device Driver (hereinafter 
//referred to as "Driver") a non-exclusive, nontransferable license 
//to use the Driver in accordance with the term set forth below.  
//Before using the Driver, the User should read the following use 
//restrictions.  If the User does not accept these terms, the Driver 
//should not be used or downloaded.
//The User is granted this limited license to use this Driver for 
//User's end product that includes the Exar XR17C158 Octal UART device, 
//and is not granted rights to sell, loan, rent, lease or license the 
//Driver, in whole or in part, or in modified form to anyone other 
//than User.  User may modify the Driver to suit its specific 
//applications but rights to derivative works and such modifications 
//shall belong to Exar.
//
//The Driver is provided on an "AS IS" basis and Exar makes absolutely 
//no warranty with respect to performance or the information contained 
//therein.  EXAR DISCLAIMS AND USER WAIVES ALL WARRANTIES, EXPRESS OR 
//IMPLIED, INCLUDING WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A 
//PARTICULAR PURPOSE.  The entire risk as to Driver quality and 
//performance is with the User.  ACCORDINGLY, IN NO EVENT SHALL EXAR 
//BE LIABLE FOR ANY DAMAGES, WHETHER IN CONTRACT OR TORT, INCLUDING 
//ANY LOST PROFITS OR OTHER INCIDENTAL, CONSEQUENTIAL, EXEMPLARY, OR 
//PUNITIVE DAMAGES ARISING OUT OF THE USE OR APPLICATION OF THE DRIVER.  
//Further, Exar reserves the right to make changes tot eh Driver without 
//notice to improve reliability, function or design.  Exar does not 
//convey any license under patent rights or any other intellectual 
//property rights, including those of third parties.
//
//Exar is not obligated to provide maintenance or support for the Driver. 
//
//Author:	Kevin Guo
//
// e2promView.cpp : implementation of the CE2promView class
//
/////////////////////////////////////////////

#include "stdafx.h"
#include "e2prom.h"

#include "e2promDoc.h"
#include "e2promView.h"

#include "myid.h"
#include "rightwrite.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CE2promView

IMPLEMENT_DYNCREATE(CE2promView, CListView)

BEGIN_MESSAGE_MAP(CE2promView, CListView)
	//{{AFX_MSG_MAP(CE2promView)
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(IDM_FLOAT_RIGHTWRITE, OnWriteRegister) 
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CE2promView construction/destruction

CE2promView::CE2promView()
{
	// TODO: add construction code here

}

CE2promView::~CE2promView()
{
}

BOOL CE2promView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style |= LVS_REPORT;
	return CListView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CE2promView drawing

void CE2promView::OnDraw(CDC* pDC)
{
	CE2promDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

void CE2promView::OnInitialUpdate()
{
	CE2promDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CListView::OnInitialUpdate();

	// TODO: You may populate your ListView with items by directly accessing
	//  its list control through a call to GetListCtrl().

	int nWidth = 20;
	CListCtrl& m_ctlListCtrl = GetListCtrl();
	m_ctlListCtrl.InsertColumn(0, "Address");
	m_ctlListCtrl.SetColumnWidth(0, 4*nWidth);
	m_ctlListCtrl.InsertColumn(1, "Value (Read)");
	m_ctlListCtrl.SetColumnWidth(1, 6*nWidth);
	m_ctlListCtrl.InsertColumn(2, "Value (Write)");
	m_ctlListCtrl.SetColumnWidth(2, 6*nWidth);
	m_ctlListCtrl.InsertColumn(3, "Info");
	m_ctlListCtrl.SetColumnWidth(3, 6*nWidth);
	m_ctlListCtrl.SetBkColor(RGB(0, 0, 0));
	m_ctlListCtrl.SetTextColor(RGB(255, 255, 255));
	m_ctlListCtrl.SetTextBkColor(RGB(0, 0, 0));

	m_ctlListCtrl.DeleteAllItems();

	int nItem;
	CString strTemp, strTemp2;
	for(int i=0; i<MAX_SIZE; i++)
	{
		char buf[5];
		if (i<16)
		{
			strTemp = "0x0";
		}
		else
		{
			strTemp = "0x";
		}
		itoa(i, buf, 16);

		strTemp2 = buf;
		strTemp2.MakeUpper();

		strTemp += strTemp2;
		

		nItem = m_ctlListCtrl.InsertItem(i, strTemp);
		m_ctlListCtrl.EditLabel(i);
		m_ctlListCtrl.SetTextColor(0xff);
	
		pDoc->dwDataRead[i] = pDoc->m_pHw->ReadE2prom(i);
		pDoc->strDataRead[i].Format("%1X", pDoc->dwDataRead[i]);

		if(pDoc->dwDataRead[i] <= 0xfff)
			pDoc->strDataRead[i].Insert(0, '0');

		m_ctlListCtrl.SetItemText(nItem, 1, pDoc->strDataRead[i] );
		m_ctlListCtrl.SetItemText(nItem, 2, " ");
		if(i==0)
			m_ctlListCtrl.SetItemText( nItem, 3, "Vendor ID" );
		else if(i==0x01)
			m_ctlListCtrl.SetItemText( nItem, 3, "Device ID" );
		else if(i==0x02)
			m_ctlListCtrl.SetItemText( nItem, 3, "Subsystem Vendor ID" );
		else if(i==0x03)
			m_ctlListCtrl.SetItemText( nItem, 3, "Subsystem ID" );
	}

		m_ctlListCtrl.SetWindowText("Please Wait....");
	
}

/////////////////////////////////////////////////////////////////////////////
// CE2promView diagnostics

#ifdef _DEBUG
void CE2promView::AssertValid() const
{
	CListView::AssertValid();
}

void CE2promView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CE2promDoc* CE2promView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CE2promDoc)));
	return (CE2promDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CE2promView message handlers

void CE2promView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CE2promDoc* pDoc = (CE2promDoc*) GetDocument();
	ASSERT_VALID(pDoc);
	CListCtrl& m_ctlListCtrl = GetListCtrl();
	int nIndex = m_ctlListCtrl.GetNextItem(-1, LVNI_SELECTED);
	
	if(nIndex != 0xffffffff)
	{
		pDoc->dwIndex = nIndex;
		CRect rect;
		this->GetWindowRect(&rect);
		CMenu FloatMenu;
		FloatMenu.CreatePopupMenu();
		FloatMenu.AppendMenu(MF_STRING, IDM_FLOAT_RIGHTWRITE, "&Write Once\tCtrl+R");  
		FloatMenu.AppendMenu(MF_SEPARATOR);	
		FloatMenu.AppendMenu(MF_STRING, IDM_FLOAT_MULTIWRITE, "&Write Many");  
		FloatMenu.TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | 
							TPM_RIGHTBUTTON, rect.left + point.x + 20, rect.top + point.y - 5, this);
	}	
	CListView::OnRButtonDown(nFlags, point);
}

void CE2promView::OnWriteRegister()
{

	CE2promDoc* pDoc = (CE2promDoc*) GetDocument();
	ASSERT_VALID(pDoc);
/*
	CListCtrl& m_ctlListCtrl = GetListCtrl();
	int nIndex = m_ctlListCtrl.GetNextItem(-1, LVNI_SELECTED);
	CString strTemp;
	strTemp = m_ctlListCtrl.GetItemText(nIndex, 0);
	int nLen = strTemp.GetLength();
	pDoc->dwFullAddr = String2Dword(strTemp.Right(nLen - 2));

	strTemp = m_ctlListCtrl.GetItemText(nIndex, 1);
	nLen = strTemp.GetLength();
	pDoc->dwOffsetValue = String2Dword(strTemp.Right(nLen - 2));

//	(CAsp4ToolTreeView *) (pDoc->m_pTreeView)->EnableWindow(FALSE);
	
	POSITION pos = pDoc->GetFirstViewPosition();
	if(pos != NULL)
	{
		CView* pView = pDoc->GetNextView(pos);
		pView->EnableWindow(FALSE);
	}   
*/
	m_pDlgRW = new CRightWrite;
	m_pDlgRW->CreateMore(pDoc);
	CRect rect;
	this->GetWindowRect(rect);
//	m_pDlgRW->MoveWindow(rect.top, rect.left + 200, 100, 120);
}

void CE2promView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
	CListCtrl& m_ctlListCtrl = GetListCtrl();
	CE2promDoc* pDoc = (CE2promDoc*) GetDocument();
	ASSERT_VALID(pDoc);

	m_ctlListCtrl.DeleteAllItems();

	for(int j=0; j<MAX_SIZE; j++)
	{
		pDoc->strDataRead[j].Format("%1X", pDoc->dwDataRead[j]);
		if(pDoc->dwDataRead[j] <= 0xfff)
			pDoc->strDataRead[j].Insert(0, '0');
		pDoc->strDataWrite[j] = " ";
	}

	pDoc->strDataWrite[pDoc->dwIndex].Format("%1X", pDoc->dwDataWrite[pDoc->dwIndex]);
	pDoc->strDataRead[pDoc->dwIndex].Format("%1X", pDoc->dwDataRead[pDoc->dwIndex]);

	int nItem;
	CString strTemp, strTemp2;
	for(int i=0; i<MAX_SIZE; i++)
	{
		char buf[6];
		if (i<16)
		{
			strTemp = "0x0";
		}
		else
		{
			strTemp = "0x";
		}
		itoa(i, buf, 16);

		strTemp2 = buf;
		strTemp2.MakeUpper();
		strTemp += strTemp2;	
		nItem = m_ctlListCtrl.InsertItem(i, strTemp);

		m_ctlListCtrl.SetTextColor( 0xff );
		m_ctlListCtrl.SetItemText( nItem, 1, pDoc->strDataRead[i] );
		m_ctlListCtrl.SetItemText( nItem, 2, pDoc->strDataWrite[i] );
		if(i==0)
			m_ctlListCtrl.SetItemText( nItem, 3, "Vendor ID" );
		else if(i==0x01)
			m_ctlListCtrl.SetItemText( nItem, 3, "Device ID" );
		else if(i==0x02)
			m_ctlListCtrl.SetItemText( nItem, 3, "Subsystem Vendor ID" );
		else if(i==0x03)
			m_ctlListCtrl.SetItemText( nItem, 3, "Subsystem ID" );
	}
}
